diff --git a/drivers/bus/vmbus/freebsd/vmbus_uio.c b/drivers/bus/vmbus/freebsd/vmbus_uio.c
new file mode 100644
index 0000000..0544371
--- /dev/null
+++ b/drivers/bus/vmbus/freebsd/vmbus_uio.c
@@ -0,0 +1,105 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2018, Microsoft Corporation.
+ * All Rights Reserved.
+ */
+
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/mman.h>
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/ioctl.h>
+
+#include <rte_log.h>
+#include <rte_bus.h>
+#include <rte_malloc.h>
+#include <rte_bus_vmbus.h>
+
+#include "private.h"
+#include "vmbus_unix.h"
+
+const char *driver_name = "hv_uio";
+
+/* Check map names with kernel names */
+static const char *map_names[VMBUS_MAX_RESOURCE] = {
+	[HV_TXRX_RING_MAP] = "txrx_rings",
+	[HV_INT_PAGE_MAP]  = "int_page",
+	[HV_MON_PAGE_MAP]  = "monitor_page",
+	[HV_RECV_BUF_MAP]  = "recv_buf",
+	[HV_SEND_BUF_MAP]  = "send_buf",
+};
+
+static int
+sysctl_get_vmbus_device_info(struct rte_vmbus_device *dev)
+{
+	char sysctl_buf[PATH_MAX];
+	char sysctl_var[PATH_MAX];
+	size_t len = PATH_MAX, sysctl_len;
+	unsigned long tmp;
+	int i;
+
+	snprintf(sysctl_buf, len, "dev.%s.%d", driver_name, dev->uio_num);
+
+	sysctl_len = sizeof(unsigned long);
+	/* get relid */
+	snprintf(sysctl_var, len, "%s.channel.ch_id", sysctl_buf);
+	if (sysctlbyname(sysctl_var, &tmp, &sysctl_len, NULL, 0) < 0) {
+		VMBUS_LOG(ERR, "could not read %s", sysctl_var);
+		goto error;
+	}
+	dev->relid = tmp;
+
+	/* get monitor id */
+	snprintf(sysctl_var, len, "%s.channel.%u.monitor_id", sysctl_buf,
+		 dev->relid);
+	if (sysctlbyname(sysctl_var, &tmp, &sysctl_len, NULL, 0) < 0) {
+		VMBUS_LOG(ERR, "could not read %s", sysctl_var);
+		goto error;
+	}
+	dev->monitor_id = tmp;
+
+	/* Extract resource value */
+	for (i = 0; i < VMBUS_MAX_RESOURCE; i++) {
+		struct rte_mem_resource *res = &dev->resource[i];
+		unsigned long size, gpad = 0;
+		size_t sizelen = sizeof(len);
+
+		snprintf(sysctl_var, sizeof(sysctl_var), "%s.%s.size",
+			 sysctl_buf, map_names[i]);
+		if (sysctlbyname(sysctl_var, &size, &sizelen, NULL, 0) < 0) {
+			VMBUS_LOG(ERR,
+				"could not read %s", sysctl_var);
+			goto error;
+		}
+		res->len = size;
+
+		if (i == HV_RECV_BUF_MAP || i == HV_SEND_BUF_MAP) {
+			snprintf(sysctl_var, sizeof(sysctl_var), "%s.%s.gpadl",
+				 sysctl_buf, map_names[i]);
+			if (sysctlbyname(sysctl_var, &gpad, &sizelen, NULL, 0) < 0) {
+				VMBUS_LOG(ERR,
+					"could not read %s", sysctl_var);
+				goto error;
+			}
+			/* put the GPAD value in physical address */
+			res->phys_addr = gpad;
+		}
+	}
+	return 0;
+error:
+	return -1;
+}
+
+/*
+ * On FreeBSD, the device is opened first to ensure kernel UIO driver
+ * is properly initialized before reading device attributes
+ */
+int vmbus_get_device_info_os(struct rte_vmbus_device *dev)
+{
+	return sysctl_get_vmbus_device_info(dev);
+}
+
+const char *get_devname_os(void)
+{
+	return "/dev/hv_uio";
+}
diff --git a/drivers/bus/vmbus/linux/vmbus_uio.c b/drivers/bus/vmbus/linux/vmbus_uio.c
index b5d15c9..69f0b26 100644
--- a/drivers/bus/vmbus/linux/vmbus_uio.c
+++ b/drivers/bus/vmbus/linux/vmbus_uio.c
@@ -199,3 +199,19 @@ int vmbus_uio_get_subchan(struct vmbus_channel *primary,
 	closedir(chan_dir);
 	return err;
 }
+
+/*
+ * In Linux the device info is fetched from SYSFS and doesn't need
+ * opening of the device before reading its attributes
+ * This is a stub function and it should always succeed.
+ */
+int vmbus_get_device_info_os(struct rte_vmbus_device *dev)
+{
+	RTE_SET_USED(dev);
+	return 0;
+}
+
+const char *get_devname_os(void)
+{
+	return "/dev/uio";
+}
diff --git a/drivers/bus/vmbus/unix/vmbus_unix.h b/drivers/bus/vmbus/unix/vmbus_unix.h
index 579c4bb..59afc10 100644
--- a/drivers/bus/vmbus/unix/vmbus_unix.h
+++ b/drivers/bus/vmbus/unix/vmbus_unix.h
@@ -20,4 +20,8 @@ int vmbus_uio_map_subchan_os(const struct rte_vmbus_device *dev,
 bool vmbus_isnew_subchannel(struct vmbus_channel *primary,
 			    unsigned long id);
 
+int vmbus_get_device_info_os(struct rte_vmbus_device *dev);
+
+const char *get_devname_os(void);
+
 #endif /* _VMBUS_BUS_UNIX_H_ */
diff --git a/drivers/bus/vmbus/unix/vmbus_unix_uio.c b/drivers/bus/vmbus/unix/vmbus_unix_uio.c
index c5ce8ca..5a57a5e 100644
--- a/drivers/bus/vmbus/unix/vmbus_unix_uio.c
+++ b/drivers/bus/vmbus/unix/vmbus_unix_uio.c
@@ -82,7 +82,8 @@ int vmbus_uio_irq_read(struct rte_vmbus_device *dev)
 	int fd;
 
 	/* save fd if in primary process */
-	snprintf(devname, sizeof(devname), "/dev/uio%u", dev->uio_num);
+	snprintf(devname, sizeof(devname), "%s%u", get_devname_os(),
+		 dev->uio_num);
 	fd = open(devname, O_RDWR);
 	if (fd < 0) {
 		VMBUS_LOG(ERR, "Cannot open %s: %s",
@@ -106,6 +107,9 @@ int vmbus_uio_irq_read(struct rte_vmbus_device *dev)
 	strlcpy((*uio_res)->path, devname, PATH_MAX);
 	rte_uuid_copy((*uio_res)->id, dev->device_id);
 
+	if (vmbus_get_device_info_os(dev) < 0)
+		goto error;
+
 	return 0;
 
 error: